//    WeIRCd administration tool
//    Copyright (C) 2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "admintool.h"

int diskconfig_Load() {
	char confpath[500];
	snprintf(confpath,499,"%s\\WEIRCDCONF.INI",localinstall_GetDataDir());
	FILE* r = fopen(confpath,"rb");
	if (!r) {
		return -1;
	}
	parser_reset();
	char buf[512];
	int i = 0;
	while (i != EOF) {
		i = fread(&buf,1,511,r);
		if (i > 0) {
			buf[i] = 0;
			int k = parser_feed(buf,i);
			if (k > 0) {
				cut(buf,k);
			}
		}else{
			buf[0] = 0;break;
		}
	}
	parser_finish();
	fclose(r);
	return 0;
}
int diskconfig_WriteUpdate() {
	generateconf_New();
	char confpath[500];
	snprintf(confpath,499,"%s\\WEIRCDCONF.INI",localinstall_GetDataDir());
	FILE* r = fopen(confpath,"w");
	if (!r) {
		return -1;
	}
	const char* p = generateconf_FetchLine();
	while (p != NULL) {
		fwrite(p,1,strlen(p),r);
		p = generateconf_FetchLine();
	}
	fclose(r);
	return 0;
}