//    WeIRCd administration tool
//    Copyright (C) 2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "admintool.h"

int localinstallationfound = 0;

#ifndef WIN
int main(int argc, char* argv) {
#endif
#ifdef WIN
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
LPSTR lpCmdLine, int nCmdShow) {
#endif
	localinstallationfound = localinstall_Find();
	if (gui_Start() < 0) {
		printf("Failed to startup GTK+ gui.\n");
		return -1;
	}
	if (gui_splash_show() < 0) {
		gdk_threads_enter();
		GtkWidget* dlg = gtk_message_dialog_new(NULL,0,
		GTK_MESSAGE_ERROR,
		GTK_BUTTONS_OK,
		"Failed to load splash image.",NULL);
		gtk_window_set_title(GTK_WINDOW(dlg),"Fatal error");
		gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER);
		gtk_dialog_run(GTK_DIALOG(dlg));
		gtk_widget_hide(dlg);
		gtk_widget_destroy(dlg);
		gdk_threads_leave();
		return -1;
	}
	if (loadwinlogo() < 0) {
		gdk_threads_enter();
		GtkWidget* dlg = gtk_message_dialog_new(NULL,0,
		GTK_MESSAGE_ERROR,
		GTK_BUTTONS_OK,
		"Failed to load application logo.",NULL);
		gtk_window_set_title(GTK_WINDOW(dlg),"Fatal error");
		gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER);
		gtk_dialog_run(GTK_DIALOG(dlg));
		gtk_widget_hide(dlg);
		gtk_widget_destroy(dlg);
		gdk_threads_leave();
		return -1;
	}
	if (loadicons() < 0) {
		gdk_threads_enter();
		GtkWidget* dlg = gtk_message_dialog_new(NULL,0,
		GTK_MESSAGE_ERROR,
		GTK_BUTTONS_OK,
		"Failed to load icons.",NULL);
		gtk_window_set_title(GTK_WINDOW(dlg),"Fatal error");
		gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER);
		gtk_dialog_run(GTK_DIALOG(dlg));
		gtk_widget_hide(dlg);
		gtk_widget_destroy(dlg);
		gdk_threads_leave();
		return -1;
	}
	unsigned long stamp = time(NULL);
	while (stamp + 3 > time(NULL)) {gui_DoLoop();}
	gui_mainwindow_Show();
	gdk_threads_enter();
	/* create tab for local installation */
#ifdef WIN
	gui_AddLocalInstTab();
#endif
#ifndef WIN
	gui_AddEmptyTab();
#endif
	/* show main window */
	gtk_widget_show (mainwindow);
	/* queue the tasks to be done once in a second */
#ifdef WIN
	g_timeout_add (1000, mainwindow_CheckStats, NULL); 
	g_timeout_add (300, mainwindow_CheckLocalRunningState, NULL); 
	g_timeout_add (200, mainwindow_CheckLocalPipe, NULL); 
#endif
	
	
	gtk_main();
	gdk_threads_leave();
	
	
	exit(0);
}