//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define MODULEFAIL_LoadingFailed 1
#define MODULEFAIL_NoInfoQuery 2
#define MODULEFAIL_NameInvalid 3
#define MODULEFAIL_NameTwice 4
#define MODULEFAIL_MallocFailed 5
#define MODULEFAIL_VersionInvalid 6
#define MODULEFAIL_NoName 7
#define MODULEFAIL_VersionTwice 8
#define MODULEFAIL_AuthorInvalid 9
#define MODULEFAIL_AuthorTwice 10
#define MODULEFAIL_CommentInvalid 11
#define MODULEFAIL_CommentTwice 12
#define MODULEFAIL_NoVersion 13
#define MODULEFAIL_ReportsFeatureTwice 14
#define MODULEFAIL_FakeUserWithoutRecv 15
#define MODULEFAIL_AccessViolation 16
#define MODULEFAIL_MissingServicesFunctions 17

typedef void (*voidfunc)(void);

extern const char* modbreakage[];

struct moduleinfo {
	char* name;
	int major; int minor; int revision;
	char* authors;
	char* comment;
	int services;
	int linking;
};
struct moduleinfo* module_QueryInfo(const char* modname);
struct moduleinfo* module_QueryInfo_NoUnload(const char* modname, void** ptr, int* dounload);
void module_FreeInfo(struct moduleinfo* inf);
int module_ModLoadError();
int printmodulelist(USER userid, const char* format);

extern const char modext[];