//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

const char error_mem[] = "Failed to allocate memory";

int conf_rehash = 0;
void cwarning(const char* content,int line) {
	char mystringle_replace[700];
	if (conf_rehash == 0) {
		if (line >= 0) {
			printf("%s    > Warning while parsing config file: In line %d:\n%s        %s\n",startupprefixsub,line,startupprefixsub,content);
		}else{
			printf("%s    > Warning while loading config/additional files:\n%s        %s\n",startupprefixsub,startupprefixsub,content);
		}
	}else{
		strcpy(mystringle_replace,"\0");
		if (line >= 0) {
			sprintf(&mystringle_replace[0],"[CONFIG] Warning while parsing config file: Error in line %d: %s",line,content);
		}else{
			sprintf(&mystringle_replace[0],"[CONFIG] Warning while loading config/additional files: %s",content);
		}
		IOnotice(mystringle_replace);
	}
	return;
}
void cerr(const char* content,int line) {
	char stringb[700];
	if (conf_rehash == 0) {
		if (line >= 0) {
			printf("%s    > Parsing config failed: Error in line %d:\n%s        %s\n",startupprefixsub,line,startupprefixsub,content);
		}else{
			printf("%s    > Error while loading config/additional files:\n%s        %s\n",startupprefixsub,startupprefixsub,content);
		}
	}else{
		strcpy(stringb,"\0");
		if (line >= 0) {
			snprintf(stringb,699,"[CONFIG] Parsing config failed: Error in line %d: %s",line,content);
		}else{
			snprintf(stringb,699,"[CONFIG] Error while loading config/additional files: %s",content);
		}
		stringb[699] = 0;
		IOnotice(stringb);
	}
	return;
}
void cinfo(const char* content) {
	char stringb[700];
	if (conf_rehash == 0) {
		printf("%s    > %s\n",startupprefixsub,content);
	}else{
		strcpy(stringb,"\0");
		snprintf(stringb,699,"[CONFIG] %s",content);
		stringb[699] = 0;
		IOnotice(stringb);
	}
	return;
}

int readconfig(int IsRehash) {	
	conf_rehash = IsRehash;
	if (IsRehash == 0) {
		printf("%s Reading config file...\n",startupprefix);
	}
	creader_ResetOpened();
	if (IsRehash == 0) {
		//only do this the first time
		if (readconfvars_Init() < 0) {
			cerr("Initialising config var management failed",-1);
			return -1;
		}
	}else{
		readconfvars_Clear();
	}
	if (creader_Init() < 0) {
		return -1;
	}
	modlist_Clear(); /* Clear the config module state list so it can be (re)filled by
	                    the config parser */
	int returnval = cblockparser_Do();
	creader_Close();
	if (returnval < 0) {
		return -1;
	}
	if (configvars_PromptMissing() < 0) {
		return -1;
	}
	readconfvars_Confirm();
	motd_Unload();
	if (config_StrVal("motdfilepath") != NULL) {
		if (motd_Load(config_StrVal("motdfilepath")) != 0) {
			cwarning("Failed to open MOTD file",-1);
		}
	}
	modlist_ApplyChanges();
	return 0;
}
