//    WeIRCd 0.7 IRC server software - main header
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd_os.h"
#include "weircd_compileoptions.h"
#include "weircd_extlibs.h"

//<--- SOME DEFINITIONS - DO NOT CHANGE --->

#ifndef alloca
#define alloca(x) __builtin_alloca(x)
#endif

typedef void *USER;



//<--- IMPORTANT GLOBAL VARS --->

extern char datadir[];
extern char moduledir[];
extern char startupprefix[];
extern char startupprefixsub[];
extern char version_copy[50];
extern char bigversion[];
extern char version_detail[];
extern int willquit;
#define FLOODLINES 8

extern char md5result[100];


#define nowimode //no +wi usermodes


//<--- API headers --->
#ifdef WIN
#define NATIVESTRLWR
#endif
#include "modules/weircd_api.h"
#include "modules/weircd_api_fakeusers.h"
#include "modules/weircd_api_services.h"

//<--- CORE  headers --->
//main structs or basic functions
#include "strings.h"
#include "ircopstruct.h"
#include "sockets.h"
#include "webircstruct.h" //needs sockets.h for IPMAXLEN
#include "channels.h"
#include "users.h" //needs sockets.h for IPMAXLEN
#include "signals.h"
#include "file.h"
#include "md5.h"

//others
#include "cmdargs.h"
#include "readconf.h"
#include "readconfvars.h"
#include "linkedlists.h"
#include "masks.h"
#include "gklines.h"
#include "startup.h"
#include "userman.h"
#include "mainloop.h"
#include "timefuncs.h"
#include "usersend.h"
#include "links.h"
#include "configvarmanager.h"
#include "configvarlistdata.h"
#include "creader.h"
#include "cblockparser.h"
#include "clineparser.h"
#include "modules.h"
#include "modulesmanager.h"
#include "modulesapi.h"
#include "irc.h"
#include "irccommands.h"
#include "mode.h"
#include "motd.h"
#include "hosts.h"
#include "modulecallrestrictions.h"
#include "modulesfakeuapi.h"
#include "modulesservicesapi.h"
#include "moduleslist.h"
#include "ips.h"
//#include "moduleschanneltrackerparser.h"

//    ---  end  --- 

